Index: /BAORadio/libindi/libindi/drivers/telescope/synscanmount.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/synscanmount.cpp	(revision 504)
+++ /BAORadio/libindi/libindi/drivers/telescope/synscanmount.cpp	(revision 504)
@@ -0,0 +1,280 @@
+/*******************************************************************************
+  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+
+  This program is free software; you can redistribute it and/or modify it
+  under the terms of the GNU General Public License as published by the Free
+  Software Foundation; either version 2 of the License, or (at your option)
+  any later version.
+
+  This program is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+  more details.
+
+  You should have received a copy of the GNU General Public License along with
+  this program; if not, write to the Free Software Foundation, Inc., 59
+  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+
+  The full GNU General Public License is included in this distribution in the
+  file called LICENSE.
+*******************************************************************************/
+#include "synscanmount.h"
+#include "libs/indicom.h"
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <stdarg.h>
+#include <math.h>
+#include <unistd.h>
+#include <time.h>
+#include <memory>
+
+#include <string.h>
+#include <sys/stat.h>
+
+// We declare an auto pointer to Synscan.
+std::auto_ptr<SynscanMount> synscan(0);
+
+void ISPoll(void *p);
+
+
+void ISInit()
+{
+   static int isInit =0;
+
+   if (isInit == 1)
+       return;
+
+    isInit = 1;
+    if(synscan.get() == 0) synscan.reset(new SynscanMount());
+    //IEAddTimer(POLLMS, ISPoll, NULL);
+
+}
+
+void ISGetProperties(const char *dev)
+{
+        ISInit();
+        synscan->ISGetProperties(dev);
+}
+
+void ISNewSwitch(const char *dev, const char *name, ISState *states, char *names[], int num)
+{
+        ISInit();
+        synscan->ISNewSwitch(dev, name, states, names, num);
+}
+
+void ISNewText(	const char *dev, const char *name, char *texts[], char *names[], int num)
+{
+        ISInit();
+        synscan->ISNewText(dev, name, texts, names, num);
+}
+
+void ISNewNumber(const char *dev, const char *name, double values[], char *names[], int num)
+{
+        ISInit();
+        synscan->ISNewNumber(dev, name, values, names, num);
+}
+
+void ISNewBLOB (const char *dev, const char *name, int sizes[], int blobsizes[], char *blobs[], char *formats[], char *names[], int n)
+{
+  INDI_UNUSED(dev);
+  INDI_UNUSED(name);
+  INDI_UNUSED(sizes);
+  INDI_UNUSED(blobsizes);
+  INDI_UNUSED(blobs);
+  INDI_UNUSED(formats);
+  INDI_UNUSED(names);
+  INDI_UNUSED(n);
+}
+void ISSnoopDevice (XMLEle *root)
+{
+    INDI_UNUSED(root);
+}
+
+SynscanMount::SynscanMount()
+{
+    //ctor
+}
+
+SynscanMount::~SynscanMount()
+{
+    //dtor
+}
+
+const char * SynscanMount::getDefaultName()
+{
+    return "SynScan";
+}
+
+bool SynscanMount::initProperties()
+{
+    if (isDebug())
+        IDLog("Synscan::init_properties\n");
+
+    //setDeviceName("Synscan");
+    INDI::Telescope::initProperties();
+
+    return true;
+}
+void SynscanMount::ISGetProperties (const char *dev)
+{
+    if (isDebug())
+        IDLog("Enter SynscanMount::ISGetProperties %s\n",dev);
+
+    //  First we let our parent class do it's thing
+    INDI::Telescope::ISGetProperties(dev);
+
+    //  Now we add anything that's specific to this telescope
+    //  or we could just load from a skeleton file too
+    return;
+}
+
+bool SynscanMount::ReadScopeStatus()
+{
+    char str[20];
+    int bytesWritten, bytesRead;
+    int numread;
+    double ra,dec;
+    int n1,n2;
+
+    //IDLog("Read Status\n");
+    //tty_write(PortFD,(unsigned char *)"Ka",2, &bytesWritten);  //  test for an echo
+
+    tty_write(PortFD,"Ka",2, &bytesWritten);  //  test for an echo
+    tty_read(PortFD,str,2,2, &bytesRead);  //  Read 2 bytes of response
+    if(str[1] != '#')
+    {
+        //  this is not a correct echo
+        if (isDebug())
+            IDLog("ReadStatus Echo Fail\n");
+        IDMessage(deviceName(),"Mount Not Responding");
+        return false;
+    }
+
+    if(TrackState==SCOPE_SLEWING)
+    {
+        //  We have a slew in progress
+        //  lets see if it's complete
+        //  This only works for ra/dec goto commands
+        //  The goto complete flag doesn't trip for ALT/AZ commands
+        memset(str,0,3);
+        tty_write(PortFD,"L",1, &bytesWritten);
+        numread=tty_read(PortFD,str,2,3, &bytesRead);
+        if(str[0]!=48)
+        {
+            //  Nothing to do here
+        } else
+        {
+            if(TrackState==SCOPE_PARKING) TrackState=SCOPE_PARKED;
+            else TrackState=SCOPE_TRACKING;
+        }
+    }
+    if(TrackState==SCOPE_PARKING)
+    {
+        //  ok, lets try read where we are
+        //  and see if we have reached the park position
+        memset(str,0,20);
+        tty_write(PortFD,"Z",1, &bytesWritten);
+        numread=tty_read(PortFD,str,10,2, &bytesRead);
+        //IDLog("PARK READ %s\n",str);
+        if(strncmp((char *)str,"0000,4000",9)==0)
+        {
+            TrackState=SCOPE_PARKED;
+            ParkSV->s=IPS_OK;
+            IDSetSwitch(ParkSV,NULL);
+            IDMessage(deviceName(),"Telescope is Parked.");
+        }
+
+    }
+
+    memset(str,0,20);
+    tty_write(PortFD,"e",1, &bytesWritten);
+    numread=tty_read(PortFD,str,18,1, &bytesRead);
+    if (numread!=18)
+    {
+        IDLog("read status bytes didn't get a full read\n");
+        return false;
+    }
+    // bytes read is as expected
+    sscanf((char *)str,"%x",&n1);
+    sscanf((char *)&str[9],"%x",&n2);
+    ra=(double)n1/0x100000000*24.0;
+    dec=(double)n2/0x100000000*360.0;
+    NewRaDec(ra,dec);
+    return true;
+}
+
+bool SynscanMount::Goto(double ra,double dec)
+{
+    char str[20];
+    int n1,n2;
+    int numread, bytesWritten, bytesRead;
+
+    //  not fleshed in yet
+    tty_write(PortFD,"Ka",2, &bytesWritten);  //  test for an echo
+    tty_read(PortFD,str,2,2, &bytesRead);  //  Read 2 bytes of response
+    if(str[1] != '#') {
+        //  this is not a correct echo
+        //  so we are not talking to a mount properly
+        return false;
+    }
+    //  Ok, mount is alive and well
+    //  so, lets format up a goto command
+    n1=ra*0x1000000/24;
+    n2=dec*0x1000000/360;
+    n1=n1<<8;
+    n2=n2<<8;
+    sprintf((char *)str,"r%08X,%08X",n1,n2);
+    tty_write(PortFD,str,18, &bytesWritten);
+    TrackState=SCOPE_SLEWING;
+    numread=tty_read(PortFD,str,1,60, &bytesRead);
+    if (numread!=1||str[0]!='#')
+    {
+        if (isDebug())
+            IDLog("Timeout waiting for scope to complete slewing.");
+        return false;
+    }
+
+    return true;
+}
+
+bool SynscanMount::Park()
+{
+    char str[20];
+    int numread, bytesWritten, bytesRead;
+
+
+    memset(str,0,3);
+    tty_write(PortFD,"Ka",2, &bytesWritten);  //  test for an echo
+    tty_read(PortFD,str,2,2, &bytesRead);  //  Read 2 bytes of response
+    if(str[1] != '#')
+    {
+        //  this is not a correct echo
+        //  so we are not talking to a mount properly
+        return false;
+    }
+    //  Now we stop tracking
+    tty_write(PortFD,"T0",2, &bytesWritten);
+    numread=tty_read(PortFD,str,1,60, &bytesRead);
+    if (numread!=1||str[0]!='#')
+    {
+        if (isDebug())
+            IDLog("Timeout waiting for scope to stop tracking.");
+        return false;
+    }
+
+    //sprintf((char *)str,"b%08X,%08X",0x0,0x40000000);
+    tty_write(PortFD,"B0000,4000",10, &bytesWritten);
+    numread=tty_read(PortFD,str,1,60, &bytesRead);
+    if (numread!=1||str[0]!='#')
+    {
+        if (isDebug())
+            IDLog("Timeout waiting for scope to respond to park.");
+        return false;
+    }
+
+    TrackState=SCOPE_PARKING;
+    IDMessage(deviceName(),"Parking Telescope...");
+    return true;
+}
Index: /BAORadio/libindi/libindi/drivers/telescope/synscanmount.h
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/synscanmount.h	(revision 504)
+++ /BAORadio/libindi/libindi/drivers/telescope/synscanmount.h	(revision 504)
@@ -0,0 +1,48 @@
+/*******************************************************************************
+  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+
+  This program is free software; you can redistribute it and/or modify it
+  under the terms of the GNU General Public License as published by the Free
+  Software Foundation; either version 2 of the License, or (at your option)
+  any later version.
+
+  This program is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+  more details.
+
+  You should have received a copy of the GNU General Public License along with
+  this program; if not, write to the Free Software Foundation, Inc., 59
+  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+
+  The full GNU General Public License is included in this distribution in the
+  file called LICENSE.
+*******************************************************************************/
+
+#ifndef SYNSCANMOUNT_H
+#define SYNSCANMOUNT_H
+
+#include "indibase/inditelescope.h"
+
+
+class SynscanMount : public INDI::Telescope
+{
+    protected:
+    private:
+    public:
+        SynscanMount();
+        virtual ~SynscanMount();
+
+        //  overrides of base class virtual functions
+        bool initProperties();
+        void ISGetProperties (const char *dev);
+        const char *getDefaultName();
+
+        bool ReadScopeStatus();
+        bool Goto(double,double);
+        bool Park();
+
+
+};
+
+#endif // SYNSCANMOUNT_H
Index: /BAORadio/libindi/libindi/drivers/telescope/telescope_simulator.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/telescope_simulator.cpp	(revision 504)
+++ /BAORadio/libindi/libindi/drivers/telescope/telescope_simulator.cpp	(revision 504)
@@ -0,0 +1,241 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <math.h>
+#include <unistd.h>
+#include <sys/time.h>
+#include <time.h>
+
+#include "telescope_simulator.h"
+#include "indicom.h"
+
+// We declare an auto pointer to ScopeSim.
+std::auto_ptr<ScopeSim> telescope_sim(0);
+
+#define	SLEWRATE	1				/* slew rate, degrees/s */
+#define	POLLMS		250				/* poll period, ms */
+#define SIDRATE		0.004178			/* sidereal rate, degrees/s */
+
+
+void ISPoll(void *p);
+
+void ISInit()
+{
+   static int isInit =0;
+
+   if (isInit == 1)
+       return;
+
+    isInit = 1;
+    if(telescope_sim.get() == 0) telescope_sim.reset(new ScopeSim());
+    //IEAddTimer(POLLMS, ISPoll, NULL);
+
+}
+
+void ISGetProperties(const char *dev)
+{
+        ISInit();
+        telescope_sim->ISGetProperties(dev);
+}
+
+void ISNewSwitch(const char *dev, const char *name, ISState *states, char *names[], int num)
+{
+        ISInit();
+        telescope_sim->ISNewSwitch(dev, name, states, names, num);
+}
+
+void ISNewText(	const char *dev, const char *name, char *texts[], char *names[], int num)
+{
+        ISInit();
+        telescope_sim->ISNewText(dev, name, texts, names, num);
+}
+
+void ISNewNumber(const char *dev, const char *name, double values[], char *names[], int num)
+{
+        ISInit();
+        telescope_sim->ISNewNumber(dev, name, values, names, num);
+}
+
+void ISNewBLOB (const char *dev, const char *name, int sizes[], int blobsizes[], char *blobs[], char *formats[], char *names[], int n)
+{
+  INDI_UNUSED(dev);
+  INDI_UNUSED(name);
+  INDI_UNUSED(sizes);
+  INDI_UNUSED(blobsizes);
+  INDI_UNUSED(blobs);
+  INDI_UNUSED(formats);
+  INDI_UNUSED(names);
+  INDI_UNUSED(n);
+}
+void ISSnoopDevice (XMLEle *root)
+{
+    INDI_UNUSED(root);
+}
+
+
+ScopeSim::ScopeSim()
+{
+    //ctor
+    currentRA=15;
+    currentDEC=15;
+    Parked=false;
+}
+
+ScopeSim::~ScopeSim()
+{
+    //dtor
+}
+
+const char * ScopeSim::getDefaultName()
+{
+    return (char *)"Telescope Simulator";
+}
+
+bool ScopeSim::Connect(char *)
+{
+    return true;
+}
+
+bool ScopeSim::Disconnect()
+{
+    return true;
+}
+
+bool ScopeSim::ReadScopeStatus()
+{
+    static struct timeval ltv;
+    struct timeval tv;
+    double dt, da, dx;
+    int nlocked;
+
+
+    /* update elapsed time since last poll, don't presume exactly POLLMS */
+    gettimeofday (&tv, NULL);
+
+    if (ltv.tv_sec == 0 && ltv.tv_usec == 0)
+        ltv = tv;
+
+    dt = tv.tv_sec - ltv.tv_sec + (tv.tv_usec - ltv.tv_usec)/1e6;
+    ltv = tv;
+    da = SLEWRATE*dt;
+
+    /* Process per current state. We check the state of EQUATORIAL_EOD_COORDS_REQUEST and act acoordingly */
+    switch (TrackState)
+    {
+    case SCOPE_SLEWING:
+    case SCOPE_PARKING:
+        /* slewing - nail it when both within one pulse @ SLEWRATE */
+        nlocked = 0;
+
+        dx = targetRA - currentRA;
+
+        if (fabs(dx) <= da)
+        {
+            currentRA = targetRA;
+            nlocked++;
+        }
+        else if (dx > 0)
+            currentRA += da/15.;
+        else
+            currentRA -= da/15.;
+
+
+        dx = targetDEC - currentDEC;
+        if (fabs(dx) <= da)
+        {
+            currentDEC = targetDEC;
+            nlocked++;
+        }
+        else if (dx > 0)
+          currentDEC += da;
+        else
+          currentDEC -= da;
+
+        if (nlocked == 2)
+        {
+            //eqNP.s = IPS_OK;
+            //eqNPR.s = IPS_OK;
+            //IDSetNumber(&eqNP, NULL);
+            //IDSetNumber(&eqNPR, "Now tracking");
+            if (TrackState == SCOPE_SLEWING)
+            {
+                TrackState = SCOPE_TRACKING;
+                IDMessage(deviceName(), "Telescope slew is complete. Tracking...");
+            }
+            else
+            {
+                TrackState = SCOPE_PARKED;
+                IDMessage(deviceName(), "Telescope parked successfully.");
+            }
+        }
+        //else
+          //  IDSetNumber(&eqNP, NULL);
+
+        break;
+
+    case SCOPE_TRACKING:
+        /* tracking */
+        /* RA moves at sidereal, Dec stands still */
+         currentRA += (SIDRATE*dt/15.);
+         break;
+
+    default:
+        break;
+    }
+
+    NewRaDec(currentRA, currentDEC);
+    return true;
+}
+
+bool ScopeSim::Goto(double r,double d)
+{
+    //IDLog("ScopeSim Goto\n");
+    targetRA=r;
+    targetDEC=d;
+    char RAStr[64], DecStr[64];
+
+    fs_sexa(RAStr, targetRA, 2, 3600);
+    fs_sexa(DecStr, targetDEC, 2, 3600);
+
+    Parked=false;
+    TrackState = SCOPE_SLEWING;
+    IDMessage(deviceName(), "Slewing to RA: %s - DEC: %s", RAStr, DecStr);
+    return true;
+}
+
+bool ScopeSim::Park()
+{
+    targetRA=0;
+    targetDEC=90;
+    Parked=true;
+    TrackState = SCOPE_PARKING;
+    IDMessage(deviceName(), "Parking telescope in progress...");
+    return true;
+}
+
+bool ScopeSim::Connect()
+{
+    //  Parent class is wanting a connection
+    //IDLog("INDI::Telescope calling connect with %s\n",PortT[0].text);
+    bool rc=false;
+
+    if(isConnected()) return true;
+
+    //IDLog("Calling Connect\n");
+
+    rc=Connect(PortT[0].text);
+
+    if(rc)
+        SetTimer(POLLMS);
+    return rc;
+}
+
+
+
+/* update the "mount" over time */
+void mountSim (void *p)
+{
+
+}
+
+
Index: /BAORadio/libindi/libindi/drivers/telescope/telescope_simulator.h
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/telescope_simulator.h	(revision 504)
+++ /BAORadio/libindi/libindi/drivers/telescope/telescope_simulator.h	(revision 504)
@@ -0,0 +1,32 @@
+#ifndef SCOPESIM_H
+#define SCOPESIM_H
+
+#include "indibase/inditelescope.h"
+
+
+class ScopeSim : public INDI::Telescope
+{
+    protected:
+    private:
+        double currentRA;
+        double currentDEC;
+        double targetRA;
+        double targetDEC;
+
+        bool Parked;
+    public:
+        ScopeSim();
+        virtual ~ScopeSim();
+
+        virtual const char *getDefaultName();
+        virtual bool Connect();
+        virtual bool Connect(char *);
+        virtual bool Disconnect();
+        virtual bool ReadScopeStatus();
+
+        bool Goto(double,double);
+        bool Park();
+
+};
+
+#endif // SCOPESIM_H
Index: /BAORadio/libindi/libindi/examples/README
===================================================================
--- /BAORadio/libindi/libindi/examples/README	(revision 503)
+++ /BAORadio/libindi/libindi/examples/README	(revision 504)
@@ -16,7 +16,9 @@
 tutorial_one: We construct a most basic (and useless) device driver to illustate basic INDI structures.
 tutorial_two:  We create a simple simulator. We will use a few handy utility functions provided by INDI like timers, string <---> number conversion, and more.
-tutorial_three:  We create a simple device, and establish a data channel with the client to transmit a FITS file. 
+tutorial_three:  We create a simple CCD simulator, and establish a data channel with the client to transmit a FITS file. 
 
 tutorial_dome and tutorial_rain are part of the inter-driver communication tutorial. 
+
+tutorial_client: We create a simple client to set the temperature of a CCD simulator (tutorial_three).
 
 Usage
@@ -45,7 +47,22 @@
 where num is the tutorial number (tutorial_one, tutorial_two, or tutorial_three).
 
+------------------------------------------------------------------------------------------
+
 For the inter-driver communications tutorial, type instead:
 
 $ indiserver -v -p 8000 ./tutorial_dome ./tutorial_rain
+
+------------------------------------------------------------------------------------------
+
+For tutorial_client. Run tutorial_three first:
+
+$ indiserver -v ./tutorial_three
+
+Then open another console tab, and run the client:
+
+$ ./tutorial_client
+
+You can connect to tutorial_three via a GUI client (e.g. KStars) before running tutorial_client. This will enable you to watch 
+changes in the driver as they occur from tutorial_client. Make sure to set the port to 7624 in KStars.
 
 ------------------------------------------------------------------------------------------
Index: /BAORadio/libindi/libindi/examples/tutorial_client.cpp
===================================================================
--- /BAORadio/libindi/libindi/examples/tutorial_client.cpp	(revision 504)
+++ /BAORadio/libindi/libindi/examples/tutorial_client.cpp	(revision 504)
@@ -0,0 +1,169 @@
+#if 0
+    Simple Client Tutorial
+    Demonstration of libindi v0.7 capabilities.
+
+    Copyright (C) 2010 Jasem Mutlaq (mutlaqja@ikarustech.com)
+
+    This library is free software; you can redistribute it and/or
+    modify it under the terms of the GNU Lesser General Public
+    License as published by the Free Software Foundation; either
+    version 2.1 of the License, or (at your option) any later version.
+
+    This library is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public
+    License along with this library; if not, write to the Free Software
+    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+
+#endif
+
+
+#include <string>
+#include <iostream>
+
+#include <string.h>
+#include <stdarg.h>
+#include <math.h>
+#include <unistd.h>
+#include <time.h>
+#include <memory>
+#include <sys/types.h>
+#include <sys/stat.h>
+
+#include <config.h>
+
+#include "indibase/baseclient.h"
+#include "indibase/basedriver.h"
+
+/* INDI Common Library Routines */
+#include "indicom.h"
+
+#include "tutorial_client.h"
+
+using namespace std;
+
+#define MYCCD "CCD Simulator"
+
+/* Our client auto pointer */
+auto_ptr<MyClient> camera_client(0);
+
+int main(int argc, char *argv[])
+{
+
+    if (camera_client.get() == 0)
+        camera_client.reset(new MyClient());
+
+
+  camera_client->setServer("localhost", 7624);
+
+  camera_client->watchDevice(MYCCD);
+
+  camera_client->connectServer();
+
+  cout << "Press any key to terminate the client.\n";
+  string term;
+  cin >> term;
+
+
+}
+
+
+/**************************************************************************************
+**
+***************************************************************************************/
+MyClient::MyClient()
+{
+    ccd_simulator = NULL;
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+MyClient::~MyClient()
+{
+
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void MyClient::setTemperature()
+{
+   INumberVectorProperty *ccd_temperature = NULL;
+
+   ccd_temperature = ccd_simulator->getNumber("CCD_TEMPERATURE");
+
+   if (ccd_temperature == NULL)
+   {
+       IDLog("Error: unable to find CCD Simulator CCD_TEMPERATURE property...\n");
+       return;
+   }
+
+   ccd_temperature->np[0].value = -20;
+   sendNewNumber(ccd_temperature);
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void MyClient::newDevice(const char *device_name)
+{
+    if (!strcmp(device_name, "CCD Simulator"))
+    {
+        IDLog("Receiving CCD Simulator Device...\n");
+
+        ccd_simulator = getDriver(MYCCD);
+
+        if (ccd_simulator == NULL)
+        {
+            IDLog("Error: unable to find CCD Simulator device...\n");
+            return;
+        }
+    }
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void MyClient::newProperty(const char *device_name, const char *property_name)
+{
+     if (!strcmp(device_name, "CCD Simulator") && !strcmp(property_name, "CCD_TEMPERATURE"))
+     {
+             IDLog("CCD_TEMPERATURE standard property defined. Attempting connection to CCD...\n");
+             setDriverConnection(true, MYCCD);
+     }
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void MyClient::newSwitch(ISwitchVectorProperty *svp)
+{
+    // Let's check if we're ON
+    if (!strcmp(svp->name, "CONNECTION"))
+    {
+        if (svp->sp[0].s == ISS_ON)
+        {
+            IDLog("CCD is connected. Setting temperature to -20 C.\n");
+            setTemperature();
+        }
+    }
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void MyClient::newNumber(INumberVectorProperty *nvp)
+{
+    // Let's check if we get any new values for CCD_TEMPERATURE
+    if (!strcmp(nvp->name, "CCD_TEMPERATURE"))
+    {
+       IDLog("Receving new CCD Temperature: %g C\n", nvp->np[0].value);
+
+       if (nvp->np[0].value == -20)
+           IDLog("CCD temperature reached desired value!\n");
+   }
+}
Index: /BAORadio/libindi/libindi/examples/tutorial_client.h
===================================================================
--- /BAORadio/libindi/libindi/examples/tutorial_client.h	(revision 504)
+++ /BAORadio/libindi/libindi/examples/tutorial_client.h	(revision 504)
@@ -0,0 +1,54 @@
+/*
+    Tutorial Client
+    Copyright (C) 2010 Jasem Mutlaq (mutlaqja@ikarustech.com)
+
+    This library is free software; you can redistribute it and/or
+    modify it under the terms of the GNU Lesser General Public
+    License as published by the Free Software Foundation; either
+    version 2.1 of the License, or (at your option) any later version.
+
+    This library is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public
+    License along with this library; if not, write to the Free Software
+    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+
+*/
+
+#ifndef TUTORIAL_CLIENT_H
+#define TUTORIAL_CLIENT_H
+
+#include "indidevapi.h"
+#include "indicom.h"
+#include "indibase/baseclient.h"
+
+class MyClient : public INDI::BaseClient
+{
+ public:
+
+    MyClient();
+    ~MyClient();
+
+    void setTemperature();
+
+protected:
+
+    virtual void newDevice(const char *device_name);
+    virtual void newProperty(const char *device_name, const char *property_name);
+    virtual void newBLOB(IBLOB *bp) {}
+    virtual void newSwitch(ISwitchVectorProperty *svp);
+    virtual void newNumber(INumberVectorProperty *nvp);
+    virtual void newText(ITextVectorProperty *tvp) {}
+    virtual void newLight(ILightVectorProperty *lvp) {}
+    virtual void serverConnected() {}
+    virtual void serverDisconnected() {}
+
+private:
+   INDI::BaseDriver * ccd_simulator;
+
+};
+
+#endif
Index: /BAORadio/libindi/libindi/examples/tutorial_four.cpp
===================================================================
--- /BAORadio/libindi/libindi/examples/tutorial_four.cpp	(revision 503)
+++ /BAORadio/libindi/libindi/examples/tutorial_four.cpp	(revision 504)
@@ -133,5 +133,5 @@
     IDLog("Initilizing from My Scope device...\n");
 
-    init_properties();
+    //init_properties();
 
  }
@@ -147,7 +147,8 @@
 /**************************************************************************************
 ** Initialize all properties & set default values.
-***************************************************************************************/
-void MyScope::init_properties()
-{
+**************************************************************************************/
+bool MyScope::initProperties()
+{
+    DefaultDriver::initProperties();
     // This is the default driver skeleton file location
     // Convention is: drivername_sk_xml
@@ -169,4 +170,6 @@
     addAuxControls();
 
+    return true;
+
 }
 
@@ -247,5 +250,5 @@
             return false;
 
-        // Are we update CONNECTION?
+        /* Are we update CONNECTION?
         if (!strcmp(svp->name, "CONNECTION"))
         {
@@ -253,40 +256,32 @@
             connect_telescope();
             return true;
-        }
-
-
-}
-
-
-/**************************************************************************************
-**
-***************************************************************************************/
-void MyScope::connect_telescope()
-{
-    ISwitchVectorProperty *svp = getSwitch("CONNECTION");
-
-    ISwitch *sp = IUFindOnSwitch(svp);
-
-    if (!sp)
-        return;
-
-    // Are we connecting?
-    if (!strcmp(sp->name, "CONNECT"))
-    {
-        // Make sure to call setConnected(true) before informing client about successful connection
-        setConnected(true);
-        IDSetSwitch(svp, "Connecting.... telescope is online.");
-        IDLog("Connecting.... telescope is online.\n");
-
-
-    }
-    // Are we disconnecting?
-    else
-    {
-        setConnected(false);
-        IDSetSwitch(svp, "Disconnecting... telescope is offline.");
-        IDLog("Disconnecting... telescope is offline.\n");
-    }
-}
-
-
+        }*/
+
+
+}
+
+
+/**************************************************************************************
+**
+***************************************************************************************/
+bool MyScope::Connect()
+{
+    return true;
+}
+
+bool MyScope::Disconnect()
+{
+    return true;
+}
+
+const char * MyScope::getDefaultName()
+{
+    return "My Scope";
+}
+
+
+
+
+
+
+
Index: /BAORadio/libindi/libindi/examples/tutorial_four.h
===================================================================
--- /BAORadio/libindi/libindi/examples/tutorial_four.h	(revision 503)
+++ /BAORadio/libindi/libindi/examples/tutorial_four.h	(revision 504)
@@ -38,6 +38,8 @@
 
 private:
- void init_properties();
- void connect_telescope();
+ const char *getDefaultName();
+ virtual bool initProperties();
+ virtual bool Connect();
+ virtual bool Disconnect();
 
 };
Index: /BAORadio/libindi/libindi/examples/tutorial_three.c
===================================================================
--- /BAORadio/libindi/libindi/examples/tutorial_three.c	(revision 503)
+++ /BAORadio/libindi/libindi/examples/tutorial_three.c	(revision 504)
@@ -66,7 +66,11 @@
 
 /* BLOB for sending image */
-static IBLOB imageB = {"CCD1", "Feed", "", 0, 0, 0, 0, 0, 0, 0};
-static IBLOBVectorProperty imageBP = {mydev, "Video", "Video", COMM_GROUP,
-  IP_RO, 0, IPS_IDLE, &imageB, 1, "", 0};
+static IBLOB imagePrimaryB = {"CCD1", "Primary", "", 0, 0, 0, 0, 0, 0, 0};
+static IBLOBVectorProperty imagePrimaryBP = {mydev, "CCD1", "", COMM_GROUP,
+  IP_RO, 0, IPS_IDLE, &imagePrimaryB, 1, "", 0};
+
+static IBLOB imageGuideB = {"CCD2", "Guide", "", 0, 0, 0, 0, 0, 0, 0};
+static IBLOBVectorProperty imageGuideBP = {mydev, "CCD2", "", COMM_GROUP,
+  IP_RO, 0, IPS_IDLE, &imageGuideB, 1, "", 0};
 
 void ISGetProperties (const char *dev)
@@ -80,5 +84,6 @@
   IDDefNumber(&ExposeTimeNP, NULL);
   IDDefNumber(&TemperatureNP, NULL);
-  IDDefBLOB(&imageBP, NULL);
+  IDDefBLOB(&imagePrimaryBP, NULL);
+  IDDefBLOB(&imageGuideBP, NULL);
 
   IEAddTimer(1000, ISPoll, NULL);
@@ -236,12 +241,27 @@
    
    /* #6 Send it */
-   imageB.blob = compressedData;
-   imageB.bloblen = compressedBytes;
-   imageB.size = totalBytes;
-   strcpy(imageB.format, ".fits.z");
+
+   if (!strcmp(filename, "ngc1316o.fits"))
+   {
+   imagePrimaryB.blob = compressedData;
+   imagePrimaryB.bloblen = compressedBytes;
+   imagePrimaryB.size = totalBytes;
+   strcpy(imagePrimaryB.format, ".fits.z");
 
    /* #7 Set BLOB state to Ok */
-   imageBP.s = IPS_OK;
-   IDSetBLOB (&imageBP, NULL);
+   imagePrimaryBP.s = IPS_OK;
+   IDSetBLOB (&imagePrimaryBP, NULL);
+   }
+   else
+   {
+       imageGuideB.blob = compressedData;
+       imageGuideB.bloblen = compressedBytes;
+       imageGuideB.size = totalBytes;
+       strcpy(imageGuideB.format, ".fits.z");
+
+       /* #7 Set BLOB state to Ok */
+       imageGuideBP.s = IPS_OK;
+       IDSetBLOB (&imageGuideBP, NULL);
+   }
 
    /* #8 Set Exposure status to Ok */
@@ -274,6 +294,8 @@
 
         /* Are we done yet? */
-        if (ExposeTimeN[0].value == 0)
+        if (ExposeTimeN[0].value <= 0)
         {
+          ExposeTimeN[0].value = 0;
+
           /* Let's set the state of OK and report that to the client */
           ExposeTimeNP.s = IPS_OK;
@@ -281,4 +303,5 @@
           /* Upload a sample FITS file */
           uploadFile("ngc1316o.fits");
+          uploadFile("x0cj010ct_d0h.fit");
 
           IDSetNumber(&ExposeTimeNP, NULL);
